#include <pspkernel.h>
#include <pspctrl.h>
#include <psppower.h>
#include <systemctrl.h>
#include <systemctrl_se.h>
#include <pspinit.h>
#include <string.h>
#include <kubridge.h>

#include <stdio.h>
#include "conf.h"


PSP_MODULE_INFO("SelectBoot", 0x1000, 0, 0);

// inipϐ ini̍ڕKv
#define INI_PATH "/selectboot.ini"
#define CONF_NUM 4
INI_Key conf[CONF_NUM];

char iniPath[128];

//pXw
#define PRO_PATH "/PRO.PBP"
#define ME_PATH "/ME.PBP"
#define XE_PATG "/XE.PBP"
#define HB_PATH "/HB.PBP"

u32 prokey = 0;
u32 mekey = 0;
u32 tnkey = 0;
u32 hbkey = 0;

int main_thread(SceSize args, void *argp);
int module_start(SceSize args, void *argp);
int module_stop(SceSize args, void *argp);

//GAMEN邽 AutoStart p
void Exec(char *gamepath)
{
	int k1 = pspSdkSetK1(0);
	
	u32 vshmain_args[0x0400/4];
	memset(vshmain_args, 0, sizeof(vshmain_args));
	vshmain_args[0x40] = 1;
	vshmain_args[0x280] = 1;
	vshmain_args[0x284] = 3;
	vshmain_args[0x286] = 5;

	struct SceKernelLoadExecVSHParam param;
	
	memset(&param, 0, sizeof(param));
	param.size = sizeof(param);
	param.args = strlen(gamepath)+1;
	param.argp = gamepath;
	param.key = "game";
	param.vshmain_args_size = sizeof(vshmain_args);
	param.vshmain_args = vshmain_args;
	param.unk4 = 0;
	param.unk5 = 0;


	sctrlKernelLoadExecVSHMs2(gamepath, &param);

	pspSdkSetK1(k1);
}

//pX擾 AutoStart p
void GetPath(char *path, void *argp)
{
	char *temp;

	strcpy(path, argp);
	temp = strrchr(path, '/');
	if( temp != NULL ) *temp = '\0';
}

//C
int main_thread(SceSize args, void *argp)
{
	//Thanks ABCanG.
	while( 1 )
	{
		if(
			sceKernelFindModuleByName("sceSystemMemoryManager") && 
			sceKernelFindModuleByName("sceIOFileManager") && 
			sceKernelFindModuleByName("sceGE_Manager") && 
			sceKernelFindModuleByName("sceDisplay_Service") && 
			sceKernelFindModuleByName("sceController_Service") && 
			sceKernelFindModuleByName("sceKernelLibrary")
		)
		{
			break;
		}
		sceKernelDelayThread(1000);
	}
	
	
	//pX
	char propath[256];
	char mepath[256];
	char xepath[256];
	char hbpath[256];
	
	//pX擾
	GetPath(propath,argp);
	GetPath(mepath,argp);
	GetPath(xepath,argp);
	GetPath(hbpath,argp);
	
	//path  PATH 
	strcat(propath, PRO_PATH);
	strcat(mepath, ME_PATH);
	strcat(xepath, XE_PATG);
	strcat(hbpath, HB_PATH);
	
	//pbh͂̂߂
	SceCtrlData pad;
	sceCtrlPeekBufferPositive(&pad, 1);

	sceKernelDelayThread(5000);
	
	//PRON
	if ( (prokey) && ((pad.Buttons& prokey) == prokey) ){
	Exec(propath);
	}
	
	//MEN
	if ( (mekey) && ((pad.Buttons& mekey) == mekey) ){
	Exec(mepath);
	}
	
	//TN XtendedN
	if ( (tnkey) && ((pad.Buttons& tnkey) == tnkey) ){
	Exec(xepath);
	}
	
	//HalfByteLoaderN
	if ( (hbkey) && ((pad.Buttons& hbkey) == hbkey) ){
	Exec(hbpath);
	}
	
	return 0;
}


int module_start(SceSize args, void *argp)
{		
	char *temp;

	//ǂݍinit@C̃pX
	strcpy(iniPath, argp);
	// ms0:/seplugins/foo.prxǂݍ(sꂽƂ), iniPath"ms0:/seplugins/foo.prx"Rs[
	temp = strrchr(iniPath, '/');
	// iniPatḧԌɂ '/' TÃ|C^[temp
	if( temp != NULL ) *temp = '\0';
	// temp == NULL'/'TȂƂ,܂ temp != NULL '/'TƂ
	// '/'EOS('\0')ɕςA܂iniPath"ms0:/seplugins"ƂȂ
	strcat(iniPath, INI_PATH);
	//iniPath̖"/***.ini"A܂܂iniPath"ms0:/seplugins/***.ini"ƂȂ	

	// init@C̓ǂݍ݂̉
	INI_Init_Key(conf);//(K{)

	INI_Add_Button(conf, "prokey", &prokey, PSP_CTRL_SELECT );
	INI_Add_Button(conf, "mekey", &mekey , PSP_CTRL_START );
	INI_Add_Button(conf, "tnkey", &tnkey ,PSP_CTRL_LTRIGGER );
	INI_Add_Button(conf, "hbkey", &hbkey ,PSP_CTRL_TRIANGLE );

	// init@C̓ǂݍ
	if(INI_Read_Conf(iniPath, conf) == -1){
		// init@C֏
		INI_Write_Conf(iniPath, conf, "\r\n");//ǂݍ߂Ȃ玩ō쐬
	}

		int thid = sceKernelCreateThread("DualBoot", main_thread, 8, 0x2000, 0, NULL);
		if(thid >= 0)sceKernelStartThread(thid, args, argp);

	return 0;
}


int module_stop(SceSize args, void *argp)
{
	return 0;
}
